# KISS

KISS (Keep It Simple, Stupid!) is a design philosophy that favors simplicity, solutions that are **as simple as possible** to achieve given task. This philosophy doesn't primarily stem from laziness and a want to save time (though these are valid reasons too), but mainly from the fact that higher [complexity](complexity.md) comes with increasingly negative effects such as the cost of development, cost of [maintenance](maintenance.md), greater probability of [bugs](bug.md) (e.g. [security](security.md) vulnerabilities) and failure, more [dependencies](dependency.md). This stance is related to technology [minimalism](minimalism.md).

Apparently the term *KISS* originated in the US Army plane engineering: the planes needed to be repairable by *stupid* soldiers with limited tools under field conditions.

**Examples** of KISS "[solutions](solution.md)" include:

- Using a [plain text](plain_text.md) TODO.txt file instead of a dedicated [bug](bug.md) tracker.
- Creating website in plain [HTML](html.md) instead of using some complex web framework such as [Wordpress](wordpress.md).
- Implementing a web left-right sweeping image gallery with HTML [iframe](iframe.md) instead of some overcomplicated [JavaScript](js.md) library. { Example stolen from [reactionary software](reactionary_software.md) website. ~drummyfish }
- Using a trivial [shell](shell.md) script for compiling your programs rather than a complex build system such as [CMake](cmake.md).
- ...

Compared to [suckless](suckless.md), [unix philosophy](unix_philosophy.md) and [LRS](lrs.md), KISS is a more general term and isn't tied to any specific group or movement, it doesn't imply any specifics but rather the general overall idea of simplicity being an advantage ([less is more](less_is_more.md), [worse is better](worse_is_better.md), ...).

[KISS Linux](kiss_linux.md) is an example of software developed under this philosophy and adapting the term itself.

## See Also

- [minimalism](minimalism.md)
- [suckless](suckless.md)
- [KILL](kill.md)
- [LRS](lrs.md)